Public Member Functions | Private Member Functions

# BuildSignalWindow Struct Reference

Inheritance diagram for BuildSignalWindow:

## Public Member Functions
| BuildSignalWindow (const WindowDesc *desc, Window *parent)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Private Member Functions
void | DrawSignalSprite (byte widget_index, SpriteID image) const
| Draw dynamic a signal-sprite in a button in the signal GUI Draw the sprite +1px to the right and down if the button is lowered.

## Detailed Description

Definition at line 1446 of file rail_gui.cpp.

## Member Function Documentation

void BuildSignalWindow::DrawSignalSprite | ( | byte | widget_index,
|  | SpriteID | image |
| ) |  |  | const`[inline, private]`

Draw dynamic a signal-sprite in a button in the signal GUI Draw the sprite +1px to the right and down if the button is lowered.

Parameters:

  | widget_index | index of this widget in the window
  | image | the sprite to draw

Definition at line 1455 of file rail_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, DrawSprite(), Sprite::height, Window::IsWidgetLowered(), NWidgetBase::pos_x, NWidgetBase::pos_y, ST_NORMAL, UnScaleByZoom(), Sprite::width, Sprite::x_offs, Sprite::y_offs, and ZOOM_LVL_GUI.

Referenced by DrawWidget().

virtual void BuildSignalWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1500 of file rail_gui.cpp.

References _cur_railtype, DrawSignalSprite(), GetRailTypeInfo(), RailtypeInfo::gui_sprites, IsInsideMM(), Window::IsWidgetLowered(), SIG_SEMAPHORE, RailtypeInfo::signals, WID_BS_ELECTRIC_PBS_OWAY, and WID_BS_SEMAPHORE_NORM.

virtual void BuildSignalWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1512 of file rail_gui.cpp.

References _convert_signal_button, _cur_signal_type, _cur_signal_variant, _remove_button_clicked, _settings_client, GUISettings::drag_signals_density, FindWindowById(), ClientSettings::gui, Window::InvalidateData(), Window::RaiseWidget(), SetWindowDirty(), SIG_ELECTRIC, ToggleRailButton_Remove(), TRANSPORT_RAIL, WC_BUILD_TOOLBAR, WC_GAME_OPTIONS, WID_BS_CONVERT, WID_BS_DRAG_SIGNALS_DENSITY_DECREASE, WID_BS_DRAG_SIGNALS_DENSITY_INCREASE, WID_BS_ELECTRIC_COMBO, WID_BS_ELECTRIC_ENTRY, WID_BS_ELECTRIC_EXIT, WID_BS_ELECTRIC_NORM, WID_BS_ELECTRIC_PBS, WID_BS_ELECTRIC_PBS_OWAY, WID_BS_SEMAPHORE_COMBO, WID_BS_SEMAPHORE_ENTRY, WID_BS_SEMAPHORE_EXIT, WID_BS_SEMAPHORE_NORM, WID_BS_SEMAPHORE_PBS, WID_BS_SEMAPHORE_PBS_OWAY, and WN_GAME_OPTIONS_GAME_SETTINGS.

virtual void BuildSignalWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1569 of file rail_gui.cpp.

References _convert_signal_button, _cur_signal_type, _cur_signal_variant, _settings_client, GUISettings::drag_signals_density, ClientSettings::gui, Window::LowerWidget(), Window::SetWidgetDisabledState(), Window::SetWidgetLoweredState(), SIG_ELECTRIC, WID_BS_CONVERT, WID_BS_DRAG_SIGNALS_DENSITY_DECREASE, WID_BS_DRAG_SIGNALS_DENSITY_INCREASE, WID_BS_ELECTRIC_NORM, and WID_BS_SEMAPHORE_NORM.

virtual void BuildSignalWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1491 of file rail_gui.cpp.

References _settings_client, GUISettings::drag_signals_density, ClientSettings::gui, SetDParam(), and WID_BS_DRAG_SIGNALS_DENSITY_LABEL.

The documentation for this struct was generated from the following file:

- src/rail_gui.cpp